<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for callErosEvent StructType
 * Meta informations extracted from the WSDL
 * - type: tns:callErosEvent
 * @subpackage Structs
 */
class CallErosEvent extends AbstractStructBase
{
    /**
     * The listParameter
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var string[]
     */
    public $listParameter;
    /**
     * Constructor method for callErosEvent
     * @uses CallErosEvent::setListParameter()
     * @param string[] $listParameter
     */
    public function __construct(array $listParameter = array())
    {
        $this
            ->setListParameter($listParameter);
    }
    /**
     * Get listParameter value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string[]|null
     */
    public function getListParameter()
    {
        return isset($this->listParameter) ? $this->listParameter : null;
    }
    /**
     * Set listParameter value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param string[] $listParameter
     * @return \StructType\CallErosEvent
     */
    public function setListParameter(array $listParameter = array())
    {
        foreach ($listParameter as $callErosEventListParameterItem) {
            // validation for constraint: itemType
            if (!is_string($callErosEventListParameterItem)) {
                throw new \InvalidArgumentException(sprintf('The listParameter property can only contain items of string, "%s" given', is_object($callErosEventListParameterItem) ? get_class($callErosEventListParameterItem) : gettype($callErosEventListParameterItem)), __LINE__);
            }
        }
        if (is_null($listParameter) || (is_array($listParameter) && empty($listParameter))) {
            unset($this->listParameter);
        } else {
            $this->listParameter = $listParameter;
        }
        return $this;
    }
    /**
     * Add item to listParameter value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \StructType\CallErosEvent
     */
    public function addToListParameter($item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The listParameter property can only contain items of string, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->listParameter[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CallErosEvent
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
