<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DestinationAddress StructType
 * @subpackage Structs
 */
class DestinationAddress extends ResponseAddress
{
    /**
     * The addressLine5
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $addressLine5;
    /**
     * The addressLine6
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $addressLine6;
    /**
     * The addressLine7
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $addressLine7;
    /**
     * The addressLine8
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $addressLine8;
    /**
     * The parcelshopName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $parcelshopName;
    /**
     * Constructor method for DestinationAddress
     * @uses DestinationAddress::setAddressLine5()
     * @uses DestinationAddress::setAddressLine6()
     * @uses DestinationAddress::setAddressLine7()
     * @uses DestinationAddress::setAddressLine8()
     * @uses DestinationAddress::setParcelshopName()
     * @param string $addressLine5
     * @param string $addressLine6
     * @param string $addressLine7
     * @param string $addressLine8
     * @param string $parcelshopName
     */
    public function __construct($addressLine5 = null, $addressLine6 = null, $addressLine7 = null, $addressLine8 = null, $parcelshopName = null)
    {
        $this
            ->setAddressLine5($addressLine5)
            ->setAddressLine6($addressLine6)
            ->setAddressLine7($addressLine7)
            ->setAddressLine8($addressLine8)
            ->setParcelshopName($parcelshopName);
    }
    /**
     * Get addressLine5 value
     * @return string|null
     */
    public function getAddressLine5()
    {
        return $this->addressLine5;
    }
    /**
     * Set addressLine5 value
     * @param string $addressLine5
     * @return \StructType\DestinationAddress
     */
    public function setAddressLine5($addressLine5 = null)
    {
        // validation for constraint: string
        if (!is_null($addressLine5) && !is_string($addressLine5)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($addressLine5)), __LINE__);
        }
        $this->addressLine5 = $addressLine5;
        return $this;
    }
    /**
     * Get addressLine6 value
     * @return string|null
     */
    public function getAddressLine6()
    {
        return $this->addressLine6;
    }
    /**
     * Set addressLine6 value
     * @param string $addressLine6
     * @return \StructType\DestinationAddress
     */
    public function setAddressLine6($addressLine6 = null)
    {
        // validation for constraint: string
        if (!is_null($addressLine6) && !is_string($addressLine6)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($addressLine6)), __LINE__);
        }
        $this->addressLine6 = $addressLine6;
        return $this;
    }
    /**
     * Get addressLine7 value
     * @return string|null
     */
    public function getAddressLine7()
    {
        return $this->addressLine7;
    }
    /**
     * Set addressLine7 value
     * @param string $addressLine7
     * @return \StructType\DestinationAddress
     */
    public function setAddressLine7($addressLine7 = null)
    {
        // validation for constraint: string
        if (!is_null($addressLine7) && !is_string($addressLine7)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($addressLine7)), __LINE__);
        }
        $this->addressLine7 = $addressLine7;
        return $this;
    }
    /**
     * Get addressLine8 value
     * @return string|null
     */
    public function getAddressLine8()
    {
        return $this->addressLine8;
    }
    /**
     * Set addressLine8 value
     * @param string $addressLine8
     * @return \StructType\DestinationAddress
     */
    public function setAddressLine8($addressLine8 = null)
    {
        // validation for constraint: string
        if (!is_null($addressLine8) && !is_string($addressLine8)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($addressLine8)), __LINE__);
        }
        $this->addressLine8 = $addressLine8;
        return $this;
    }
    /**
     * Get parcelshopName value
     * @return string|null
     */
    public function getParcelshopName()
    {
        return $this->parcelshopName;
    }
    /**
     * Set parcelshopName value
     * @param string $parcelshopName
     * @return \StructType\DestinationAddress
     */
    public function setParcelshopName($parcelshopName = null)
    {
        // validation for constraint: string
        if (!is_null($parcelshopName) && !is_string($parcelshopName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($parcelshopName)), __LINE__);
        }
        $this->parcelshopName = $parcelshopName;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DestinationAddress
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
