<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ParcelshopDelivery StructType
 * @subpackage Structs
 */
class ParcelshopDelivery extends AbstractStructBase
{
    /**
     * The firstnameCust
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $firstnameCust;
    /**
     * The lastnameCust
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $lastnameCust;
    /**
     * The psAccNum
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $psAccNum;
    /**
     * Constructor method for ParcelshopDelivery
     * @uses ParcelshopDelivery::setFirstnameCust()
     * @uses ParcelshopDelivery::setLastnameCust()
     * @uses ParcelshopDelivery::setPsAccNum()
     * @param string $firstnameCust
     * @param string $lastnameCust
     * @param string $psAccNum
     */
    public function __construct($firstnameCust = null, $lastnameCust = null, $psAccNum = null)
    {
        $this
            ->setFirstnameCust($firstnameCust)
            ->setLastnameCust($lastnameCust)
            ->setPsAccNum($psAccNum);
    }
    /**
     * Get firstnameCust value
     * @return string|null
     */
    public function getFirstnameCust()
    {
        return $this->firstnameCust;
    }
    /**
     * Set firstnameCust value
     * @param string $firstnameCust
     * @return \StructType\ParcelshopDelivery
     */
    public function setFirstnameCust($firstnameCust = null)
    {
        // validation for constraint: string
        if (!is_null($firstnameCust) && !is_string($firstnameCust)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($firstnameCust)), __LINE__);
        }
        $this->firstnameCust = $firstnameCust;
        return $this;
    }
    /**
     * Get lastnameCust value
     * @return string|null
     */
    public function getLastnameCust()
    {
        return $this->lastnameCust;
    }
    /**
     * Set lastnameCust value
     * @param string $lastnameCust
     * @return \StructType\ParcelshopDelivery
     */
    public function setLastnameCust($lastnameCust = null)
    {
        // validation for constraint: string
        if (!is_null($lastnameCust) && !is_string($lastnameCust)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lastnameCust)), __LINE__);
        }
        $this->lastnameCust = $lastnameCust;
        return $this;
    }
    /**
     * Get psAccNum value
     * @return string|null
     */
    public function getPsAccNum()
    {
        return $this->psAccNum;
    }
    /**
     * Set psAccNum value
     * @param string $psAccNum
     * @return \StructType\ParcelshopDelivery
     */
    public function setPsAccNum($psAccNum = null)
    {
        // validation for constraint: string
        if (!is_null($psAccNum) && !is_string($psAccNum)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($psAccNum)), __LINE__);
        }
        $this->psAccNum = $psAccNum;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ParcelshopDelivery
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
