<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for scannedAndShippedToCHE StructType
 * Meta informations extracted from the WSDL
 * - type: tns:scannedAndShippedToCHE
 * @subpackage Structs
 */
class ScannedAndShippedToCHE extends AbstractStructBase
{
    /**
     * The listShippedBarcodesHermes
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var string[]
     */
    public $listShippedBarcodesHermes;
    /**
     * Constructor method for scannedAndShippedToCHE
     * @uses ScannedAndShippedToCHE::setListShippedBarcodesHermes()
     * @param string[] $listShippedBarcodesHermes
     */
    public function __construct(array $listShippedBarcodesHermes = array())
    {
        $this
            ->setListShippedBarcodesHermes($listShippedBarcodesHermes);
    }
    /**
     * Get listShippedBarcodesHermes value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string[]|null
     */
    public function getListShippedBarcodesHermes()
    {
        return isset($this->listShippedBarcodesHermes) ? $this->listShippedBarcodesHermes : null;
    }
    /**
     * Set listShippedBarcodesHermes value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param string[] $listShippedBarcodesHermes
     * @return \StructType\ScannedAndShippedToCHE
     */
    public function setListShippedBarcodesHermes(array $listShippedBarcodesHermes = array())
    {
        foreach ($listShippedBarcodesHermes as $scannedAndShippedToCHEListShippedBarcodesHermesItem) {
            // validation for constraint: itemType
            if (!is_string($scannedAndShippedToCHEListShippedBarcodesHermesItem)) {
                throw new \InvalidArgumentException(sprintf('The listShippedBarcodesHermes property can only contain items of string, "%s" given', is_object($scannedAndShippedToCHEListShippedBarcodesHermesItem) ? get_class($scannedAndShippedToCHEListShippedBarcodesHermesItem) : gettype($scannedAndShippedToCHEListShippedBarcodesHermesItem)), __LINE__);
            }
        }
        if (is_null($listShippedBarcodesHermes) || (is_array($listShippedBarcodesHermes) && empty($listShippedBarcodesHermes))) {
            unset($this->listShippedBarcodesHermes);
        } else {
            $this->listShippedBarcodesHermes = $listShippedBarcodesHermes;
        }
        return $this;
    }
    /**
     * Add item to listShippedBarcodesHermes value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \StructType\ScannedAndShippedToCHE
     */
    public function addToListShippedBarcodesHermes($item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The listShippedBarcodesHermes property can only contain items of string, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->listShippedBarcodesHermes[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ScannedAndShippedToCHE
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
